<?php declare(strict_types=1);

require __DIR__ . '/../vendor/autoload.php';

use JTL\Helpers\URL;
use JTL\Session\Frontend;
use Plugin\PunchCommerce\src\TransformBasketForPunchCommerce;

/** @global \JTL\Smarty\JTLSmarty $smarty */
/** @global JTL\Plugin\PluginInterface $plugin */

$type = Frontend::get('punchcommerce_session_type');
$id = Frontend::get('punchcommerce_session_id');

if ($type === null) {
    $linkHelper = Shop::Container()->getLinkService();
    $link = $linkHelper->getSpecialPage(LINKTYP_STARTSEITE);
    $link->setRedirectCode(301);

    $url = URL::buildURL($link, URLART_SEITE);
    header('Location: ' . $url, true, $link->getRedirectCode());
    exit();
}

$config = $plugin->getConfig();

$transform = new TransformBasketForPunchCommerce();
$result = $transform($config);

$hostname = $config->getValue('punchcommerce_url');
$service = "/gateway/v3/return/{$id}";
$url = $hostname . $service;

$smarty->assign('Warenkorb', Frontend::getCart());
$smarty->assign('Einstellungen', Shop::getSettings([CONF_GLOBAL, CONF_ARTIKELUEBERSICHT, CONF_KAUFABWICKLUNG, CONF_ARTIKELUEBERSICHT]));
$smarty->assign('target', $url);
$smarty->assign('payload', json_encode($result, JSON_THROW_ON_ERROR));
$smarty->assign('id', $id);
